﻿// For an introduction to the Blank template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkID=397704
// To debug code on page load in Ripple or on Android devices/emulators: launch your app, set breakpoints, 
// and then run "window.location.reload()" in the JavaScript Console.
(function () {
    "use strict";

    document.addEventListener( 'deviceready', onDeviceReady.bind( this ), false );

    function onDeviceReady() {
        // Handle the Cordova pause and resume events
        document.addEventListener( 'pause', onPause.bind( this ), false );
        document.addEventListener( 'resume', onResume.bind( this ), false );
        
        Globalize.culture('de-DE');
        var stSatzVoll = 0.19;
        var stSatzErmaessigt = 0.07;
        function DefaultViewModel() {
            var self = this;

            self.netto = ko.observable(0);
            self.steuer = ko.observable(0);
            self.brutto = ko.observable(0);
            self.rawBrutto = ko.observable('');
            self.rawNetto = ko.observable('');
            self.inpNetto = ko.computed({
                read: function () {
                    return Globalize.format(self.netto(), "c");
                },
                write: function () {
                },
                owner: this
            });
            self.inpSteuer = ko.computed({
                read: function () {
                    return Globalize.format(self.steuer(), "c");
                },
                write: function () {

                },
                owner: this
            });
            self.inpBrutto = ko.computed({
                read: function () {
                    return Globalize.format(self.brutto(), "c");
                },
                write: function () {
                },
                owner: this
            });
            self.typ = ko.observable('bn');
            self.satz = ko.observable('v');
            self.btnBerechnenClick = function () {

            };

            var calculate = function () {
                if (self.typ() === 'bn') {
                    self.netto(self.brutto() / (1 + (self.satz() === 'v' ? stSatzVoll : stSatzErmaessigt)));
                    self.steuer(self.brutto() * (1 - 1 / (1 + (self.satz() === 'v' ? stSatzVoll : stSatzErmaessigt))));
                } else {
                    self.steuer(self.netto() * (self.satz() === 'v' ? stSatzVoll : stSatzErmaessigt));
                    self.brutto(self.netto() * (1 + (self.satz() === 'v' ? stSatzVoll : stSatzErmaessigt)));
                }
            };

            self.btnZahlClick = function () {
                var value = arguments[1].target.innerHTML;
                if (self.typ() === 'bn') {
                    //var stringVal = self.inpBrutto();
                    //var floatVal = Globalize.parseFloat(stringVal);
                    //stringVal = floatVal.toString() + value;
                    self.rawBrutto(self.rawBrutto() + value);
                    //var floatVal = Globalize.parseFloat(self.rawBrutto());
                    //self.brutto(floatVal);
                } else {
                    //self.inpNetto(self.inpBrutto() + value);
                    //stringVal = self.inpNetto();
                    //floatVal = Globalize.parseFloat(stringVal);
                    //stringVal = floatVal.toString() + value;
                    self.rawNetto(self.rawNetto() + value);
                    //floatVal = Globalize.parseFloat(self.rawNetto());
                    //self.netto(floatVal);
                }
            };

            self.btnKommaClick = function () {
                if (self.typ() === 'bn') {
                    self.rawBrutto(self.rawBrutto() + ',');
                } else {
                    self.rawNetto(self.rawNetto() + ',');
                }
            };

            self.btnDeleteClick = function () {
                if (self.typ() === 'bn') {

                    self.rawBrutto('0');
                } else {
                    self.rawNetto('0');

                }
            };

            self.rawBrutto.subscribe(function () {
                var floatVal = Globalize.parseFloat(self.rawBrutto());
                self.brutto(floatVal);
            });

            self.rawNetto.subscribe(function () {
                var floatVal = Globalize.parseFloat(self.rawNetto());
                self.netto(floatVal);
            });

            self.brutto.subscribe(function () {
                calculate();
            });

            self.netto.subscribe(function () {
                calculate();
            });

            self.satz.subscribe(function () {
                calculate();
            });
        }

        var model = new DefaultViewModel();
        ko.applyBindings(model);
    };

    function onPause() {
        // TODO: This application has been suspended. Save application state here.
    };

    function onResume() {
        // TODO: This application has been reactivated. Restore application state here.
    };
} )();